#include <conio.h>
#include <dos.h>
#include <io.h>
#include <fcntl.h>
#include <string.h>
#include <sys\stat.h>
#include <mem.h>
#include <alloc.h>
#include <ctype.h>
#include <graphics.h>

void put_vga_pixel(unsigned int x, unsigned int y , char col );
void vgainit( char mode );
void initmodes( int mod );
int huge detectVGA256(void);

int xsize;
int ysize;
unsigned int extended_vga_xsize;
char current_vga_page,
     last_vga_page,
     color,
     videomode,
     readmode;

void vgainit( char mode )
{
 asm {
  mov ah,0
  mov al,mode
  int 10h
     }
}

void setxysize(int x,int y)
{
 xsize = x;
 ysize = y;
}

void initmodes( int videomode )
{
  vgainit( videomode );
  if ( videomode==19 ) setxysize(319,199);
  if ( videomode==92 ) setxysize(639,399);
  if ( videomode==93 ) setxysize(639,479);
  if ( videomode==94 ) setxysize(799,599);
  if ( videomode==98 ) setxysize(1023,767);
  extended_vga_xsize=xsize+1;
}

void put_vga_pixel(unsigned int x, unsigned int y , char col )
{
  asm {
       mov ax,x
       add ax,y
       mov dx,0
       mov bx,3
       mov bx,3
       div bx
       mov al,col
       mov color,al

     //extended_vga:
       mov dx,0xA000
       mov es,dx
       mov ax,extended_vga_xsize
       mul y
       add ax,x
       adc dx,0
       mov bx,ax
       mov current_vga_page,dl
       cmp dl,last_vga_page
       je put_pixel;
       jmp change_vga_page
     }
 vissza:
 put_pixel:
 asm {
      //put_pixel:
      mov ah,col
      mov es:[bx],ah
      jmp endpixel
     }

 change_vga_page:
 asm {
      mov ah,current_vga_page
      mov dx,0x3C4
      mov al,0xE
      out dx,al
      mov dx,0x3C5
      in al,dx
      and ax,0xFF0
      xor ah,2
      or al,ah
      out dx,al
      mov dl,current_vga_page
      mov last_vga_page,dl;
      jmp vissza
     }

 endpixel:;
}

void set_vga_page( char c_vga_page )
{
 asm {
      mov ah,c_vga_page
      mov dx,0x3C4
      mov al,0xE
      out dx,al
      mov dx,0x3C5
      in al,dx
      and ax,0xFF0
      xor ah,2
      or al,ah
      out dx,al
      mov dl,c_vga_page
      mov last_vga_page,dl;
     }
}


void makepalette( void )
{
 struct s_pt
  {
   char r,g,b;
  };
 s_pt pt[256];

 union REGPACK reg;

 char i;

 for (i=0; i<=63; i++)
  {
   pt[i].r=i; pt[i].g=i; pt[i].b=i;
   //pt[127-i].r=i; pt[127-i].g=i; pt[127-i].b=i;
  }

 reg.r_ax = 0x10 << 8 | 0x12 ;
 reg.r_bx = 0;
 reg.r_cx = 128;
 reg.r_es = _DS;
 reg.r_dx = (unsigned)pt;

 intr(0x10, &reg);
}

/***********************************************/

void main ( int argc , char *argv[] )
{
 int c,ch;
 char mt[800];
 char mt2[800];
 char mt3[800];
 char mt4[800];
 char mtx[400];
 char at;
 int font1,font2;

 //initmodes( 19 );
 int gdriver, gmode;

 /* install a user written device driver */
 gdriver = installuserdriver("VGA256", detectVGA256);

 /* must force use of detection routine */
 gdriver = DETECT;

 /* initialize graphics and local variables */
 initgraph(&gdriver, &gmode, "");


 /* install a user defined font file */
 // STEP 2 -> font1 = installuserfont("EURO.CHR");
 //font1 = installuserfont("LCOM.CHR");
 // STEP 1 -> font1 = installuserfont("SIMP.CHR");

 //put_vga_pixel (500,500,50 );
 //for (c=0 ; c<=255 ; c++ )
 // put_vga_pixel (c,c,c );
 int fh;
 int x,y;

 makepalette();

 char far *scrn;
 char far *scrn2;
 char *sb;
 scrn=(char far *)MK_FP(0xA000,0);
 scrn2=(char far *)MK_FP(0xA000,32000);
 char fnev[50];

 y=0;
 fh=open("$64.VGA", O_BINARY | O_RDWR);

 sb=(char *)malloc(32000);
 read( fh,sb, 32000 );
 _fmemcpy( scrn , sb , 32000 );
 read( fh,sb, 32000 );
 _fmemcpy( scrn2 , sb , 32000 );

 /* STEP 1 *
 setfillstyle(1,150);
 settextjustify(0,2);
 settextstyle( font1 ,0, 4 );
 setusercharsize(3,2 , 1,1);
 for (c=0 ; c<=3; c++ )
  {
   setcolor(148+c);
   outtextxy(1+c,157,"Lemezkatalogus");
   outtextxy(1+c+5,157-2,"            '   ");
  }
 **************/

 /******** STEP 2 *****
 setfillstyle(1,150);
 settextjustify(0,2);
 settextstyle( font1 ,1, 2 );
 setusercharsize(3,5 , 1,1);
 for (c=0 ; c<=3; c++ )
  {
   setcolor(158+7+c);
   outtextxy(251+c,-3,"NOSASOFT");
  }
 ********/


 /******** CROP *
 setcolor(0);
 line(0,161,280,161);
 line(0,160,280,160);
 ***********/

 x=0;
 y=0;
 int mx1,mx2,my1,my2,stt,cl;

 int sp;

 sp=getpixel(x,y);

 do
  {
   ch=toupper(getch());
   putpixel(x,y,sp);
   switch (ch)
    {
     case ' ':putpixel(x,y,(sp==63) ? 0 : 63);
             break;
     case '-':putpixel(x,y,(sp>0) ? sp-1 : sp);
             break;
     case '+':putpixel(x,y,(sp<255) ? sp+1 : sp);
             break;

     case  72:if (y<1) break;
              y--;
             break;
     case  80:if (y>=199) break;
              y++;
             break;
     case  75:if (y<1) break;
              x--;
             break;
     case  77:if (y>=319) break;
              x++;
             break;
    }
   sp=getpixel(x,y);
   putpixel(x,y,(sp>63 || sp<40) ? 63 : 0 );
  }
 while (ch != 27);

 ch=toupper(getch());

 if (ch=='S')
  {
   lseek( fh,0,SEEK_SET );
   _fmemcpy( sb , scrn , 32000 );
   write( fh,sb, 32000 );
   _fmemcpy( sb , scrn2 , 32000 );
   write( fh,sb, 32000 );
  }

 close(fh);

 //initmodes( 3 );
 closegraph();
}


/* detects VGA cards */
int huge detectVGA256(void)
{
   int driver, mode, sugmode = 0;

   detectgraph(&driver, &mode);
   if (driver == VGA)
      /* return suggested video mode number */
      return sugmode;
   else
      /* return an error code */
      return grError;
}
